.586
.model flat, stdcall
option casemap:none
include windows.inc
include kernel32.inc
includelib kernel32.lib
include user32.inc
includelib user32.lib

;***************************************************************************************************

CR equ 13
LF equ 10

;***************************************************************************************************

.const
progname    db "notepad.exe",0
errCreate   db "Failed to start the process.",CR,LF
entree      db "Starting program...",CR,LF
finito      db "The program finished.",CR,LF

.data?
hStdOut     HANDLE  ?
hStdErr     HANDLE  ?
nIOBytes    DWORD   ?

stInfo      STARTUPINFO <?>
procInfo    PROCESS_INFORMATION <?>

.code
start:
    invoke GetStdHandle, STD_OUTPUT_HANDLE
    mov hStdOut,eax
    invoke GetStdHandle, STD_ERROR_HANDLE
    mov hStdErr,eax

    push esi
    push ebx

    mov esi,OFFSET progname

    mov ebx,OFFSET stInfo
    assume ebx:ptr STARTUPINFO
    xor eax,eax
    mov [ebx].cb,SIZEOF stInfo
    mov [ebx].lpReserved,eax
    mov [ebx].lpDesktop,eax
    mov [ebx].lpTitle,eax
    mov [ebx].dwFlags,eax
    mov DWORD PTR [ebx].wShowWindow,eax   ;also zeroes 'cbReserved2'
    mov [ebx].lpReserved2,eax
    assume edx:nothing

    invoke CreateProcess, eax,esi,eax,eax,TRUE,eax,eax,eax,ebx,ADDR procInfo
    .IF (eax)
        invoke WriteFile, hStdOut,ADDR entree,SIZEOF entree,ADDR nIOBytes,NULL

        mov ebx,[procInfo.hProcess]
        invoke WaitForSingleObject, ebx,-1

        invoke WriteFile, hStdOut,ADDR finito,SIZEOF finito,ADDR nIOBytes,NULL
    .ELSE
        invoke WriteFile, hStdErr,ADDR errCreate,SIZEOF errCreate,ADDR nIOBytes,NULL
    .ENDIF

    pop ebx
    pop esi
    invoke ExitProcess, NULL

end start
